{program Doit;}

{$DEFINE COPROC}

{$IFDEF WINDOWS}
uses synaser,dos,wincrt;
var
ser:TBlockSerial;
TheComPort : string;
{$ELSE}
uses dos,crt;
var TheComPort : word;
{$ENDIF}

var
OurData : comp;
Parameter : longint;
Output : comp;
Retcode : integer;
UseHex : boolean;
DoRepeat : boolean;
temp : comp;
ParmLoc : integer;
ParmName : string;
Message : string;
c : char;
index : integer;

{$I SELECTC}
{$I SELECTIO}
{I SELECTP}
{$I SELECTPR}
{$I INTERFCE}

const
NumberOfChannels = 8;
DataStride = 4; {bytes}

var
count : longint;
Data : longint;
Errors : byte;
Status_State : byte;
Status : byte;
State : byte;
Command : word;
Wait : longint;

procedure Error(err : integer);
begin
  writeln(errorrecord[err].errstr);
  halt(2);
end;
procedure Usage;
begin
  writeln('Usage: Doit value [axis] [h] [r]');
  writeln;
  halt(2);
end;

procedure GetParameter;
var
hstring,nstring : string;
wtemp : byte;
begin
  UseHex := false;
  if length(ParamStr(1)) = 0 then Usage;
  for index := 2 to 4 do
  begin
    if length(ParamStr(index)) > 0 then
    begin
      if upstring(ParamStr(index)) = 'H' then UseHex := true;
      if upstring(ParamStr(index)) = 'R' then DoRepeat := true;
    end;
  end;

  if UseHex = false then
  begin
    val(ParamStr(1),temp,Retcode);
    if retcode = 0 then OurData := temp else Usage;
  end
  else
  begin
    if not HexDoubleRead(ParamStr(1),OurData) then Usage;
   end;
  if length(ParamStr(2)) > 0 then
  begin
    val(ParamStr(2),wtemp,Retcode);
    if retcode = 0 then Axis := wtemp;
  end;
end;  { GetParameter }

begin
  GetParameter;
  GetOurEnv;
  if not InitializeInterface(message) then bumout(message);
  repeat
    Write32(InterfacePort0+(Axis*DataStride),DoubleLongRec(OurData).Long0);
    Write32(InterfacePort1+(Axis*DataStride),DoubleLongRec(OurData).Long1);

    if not AxisDoit(Axis) then
    begin
      writeln('Failed Transfer');
      SSLBPdump(axis);
      halt(2);
    end;
    HexPrint(Read32(InterfacePort2+(Axis*DataStride)),8);
    HexPrint(Read32(InterfacePort1+(Axis*DataStride)),8);
    HexPrint(Read32(InterfacePort0+(Axis*DataStride)),8);
    Writeln;
    {delay(3);}
  until (not DoRepeat) or KeyPressed;

  halt(0);
end.

