program DUMP;

{$IFDEF WINDOWS}
uses synaser,dos,wincrt;
var
ser:TBlockSerial;
TheComPort : string;
{$ELSE}
uses dos,crt;
var TheComPort : word;
{$ENDIF}

var
OurChannel : integer;
BasePort : word;
Parameter : longint;
Output : comp;
Retcode : integer;
UseHex : boolean;
DoRepeat : boolean;
temp : word;
ParmLoc : integer;
ParmName : string;
Message : string;
c : char;

{$I SELECTC}
{$I SELECTIO}
{I SELECTP}
{$I SELECTPR}
{$I INTERFCE}

const
NumberOfChannels = 8;
DataStride = 4; {bytes}

var
FailedTransferCount : array[0..7] of longint;
count : longint;
Data : longint;
Errors : byte;
Status_State : byte;
Status : byte;
State : byte;
Command : word;
Wait : longint;

procedure ClearFailedTransferCount;
var index : integer;
begin
  for index := 0 to 7 do
  begin
    FailedTransferCount[index] := 0;
  end;
end;

procedure Error(err : integer);
begin
  writeln(errorrecord[err].errstr);
  halt(2);
end;

procedure Barfout(es:string);
begin
  writeln;
  writeln(es);
  halt(2);
end;

procedure GetParameter;
begin
  OurChannel := 0;
  if ParamCount > 0 then val(ParamStr(1),OurChannel,retcode);
  if retcode <>0 then barfout('Invalid Channel');
  SSerial := 0;
  if ParamCount > 1 then val(ParamStr(2),SSerial,retcode);
  if retcode <>0 then barfout('Invalid Module');
end;  { GetParameter }

procedure Runit(OurChannel : byte);
var channel : integer;
longdata : longint;
failedchannels : byte;
index : byte;
data : byte;
begin
  longdata := Read32(CommandPort+(OurChannel*DataStride));
  write('Command Port  '); hexprint(longdata,4); writeln;

  longdata := Read32(OurDataPort+(OurChannel*DataStride));
  data := byte(longdata and $FF);
  write('Data Port       '); hexprint(data,2); writeln;

  longdata := Read32(CSRPort+(OurChannel*DataStride));
  write('CSR Port        ');
  write('ID '); hexprint(longintbyterec(longdata).byte3,2);
  write(' State '); hexprint(longintbyterec(longdata).byte2,2);
  write(' Status '); hexprint(longintbyterec(longdata).byte1,2);
  write(' Error '); hexprint(longintbyterec(longdata).byte0,2);
  writeln;

  longdata := Read32(InterfacePort0+(OurChannel*DataStride));
  write('Interface Port0 '); hexprint(longdata,8); writeln;

  longdata := Read32(InterfacePort1+(OurChannel*DataStride));
  write('Interface Port1 '); hexprint(longdata,8); writeln;

  longdata := Read32(InterfacePort2+(OurChannel*DataStride));
   write('Interface Port2 '); hexprint(longdata,8); writeln;

  failedchannels := data;
    if failedchannels <> 0 then
    begin
      for index := 0 to 7 do
      begin
        if (failedchannels and (1 shl index)) <> 0 then
        begin
          FailedTransferCount[index] := FailedTransferCount[index] + 1;
          writeln('Failed Transfers #',index,' ',FailedTransferCount[index]);
        end;
      end;
  end;
  {Stop;}
end;

begin
  GetParameter;
  GetOurEnv;
  Message := 'Normal Mode';
  if not InitializeInterface(message) then bumout(Message);
  Runit(OurChannel);
  halt(0);
end.

