{N+}
program LEDS;

{$IFDEF WINDOWS}
uses synaser,dos,wincrt;
var
ser:TBlockSerial;
TheComPort : string;
{$ELSE}
uses dos,crt;
var TheComPort : word;
{$ENDIF}

var
OurChannel : integer;
BasePort : word;
Parameter : longint;
Output,Input : comp;
Retcode : integer;
UseHex : boolean;
DoRepeat : boolean;
temp : word;
ParmLoc : integer;
ParmName : string;
Message : string;
c : char;
foo : longint;
StartedChannels : byte;

{$I SELECTC}
{$I SELECTIO}
{I SELECTP}
{$I SELECTPR}
{$I INTERFCE}

const
NumberOfChannels = 8;
DataStride = 4; {bytes}

var
FailedTransferCount : array[0..7] of longint;
count : longint;
Data : longint;
Errors : byte;
Status_State : byte;
Status : byte;
State : byte;
Command : word;
Wait : longint;

procedure ClearFailedTransferCount;
var index : integer;
begin
  for index := 0 to 7 do
  begin
    FailedTransferCount[index] := 0;
  end;
end;

procedure Error(err : integer);
begin
  writeln(errorrecord[err].errstr);
  halt(2);
end;

procedure Barfout(es:string);
begin
  writeln;
  writeln(es);
  halt(2);
end;

procedure GetParameter;
begin
  OurChannel := 0;
  val(ParamStr(1),OurChannel,retcode);
end;  { GetParameter }

procedure Runit;
var channel : integer;
longdata : longint;
failedchannels : byte;
index : byte;
csrdata : longint;
begin
  ClrScr;
  Count := 0;
  Write32(CSRPort+(OurChannel*DataStride),0);
  SSLBPStopAll{(OurChannel)};
  StartedChannels := Start($FF);
  write('Started bit mask  ');
  hexprint(StartedChannels,2);
  writeln;

  Output := 1;
  while not Keypressed do
  begin
    GotoXY(1,2);
    writeln(Count);
    for Channel := 0 to NumberOfChannels-1 do
    begin
      if StartedChannels and (1 shl Channel) = 0 then
      begin
        Write32(InterfacePort0+(Channel*DataStride),DoubleLongRec(Output).long0);
        Write32(InterfacePort1+(Channel*DataStride),DoubleLongRec(Output).long1);
        Write32(InterfacePort2+(Channel*DataStride),DoubleLongRec(Output).long0);
      end;
    end;
    failedchannels := Doit($FF{StartedChannels});
    csrdata := Read32(CSRPort+(OurChannel*DataStride));
    if failedchannels <> 0 then
    begin
      for index := 0 to 7 do
      begin
        if (failedchannels and (1 shl index)) <> 0 then
        begin
          FailedTransferCount[index] := FailedTransferCount[index] + 1;
          gotoxy(1,index+3);
          writeln('Failed Transfers # ',index,'  ',FailedTransferCount[index]);
          write('CSR ');
          hexprint(csrdata,8);
          writeln;
        end;
      end;
    end;
    if longintbyterec(csrdata).byte3 <> 0 then
    begin
      write('Remote Fault ');
      hexprint(longintbyterec(csrdata).byte3 ,2);
      writeln;
      halt(2);
    end;
    if longintbyterec(csrdata).byte0 <> 0 then
    begin
      write('SSLBP Error ');
      hexprint(longintbyterec(csrdata).byte0 ,2);
      writeln;
      halt(2);
    end;
    HexPrint(Read32(InterfacePort2+(Axis*DataStride)),8);
    HexPrint(Read32(InterfacePort1+(Axis*DataStride)),8);
    HexPrint(Read32(InterfacePort0+(Axis*DataStride)),8);
    Writeln;
    Output := Output + Output;
    if Output > 282e12 then Output := 1; { start again }
    Count := Count+1;
    delay(10);
  end;
  for Channel := 0 to NumberOfChannels-1 do
  begin
    Write32(InterfacePort0+(Channel*DataStride),$800001);
    Write32(InterfacePort1+(Channel*DataStride),$800001);
    Write32(InterfacePort2+(Channel*DataStride),$800001);
    failedchannels := Doit($FF{StartedChannels});
  end;
  SSLBPStopAll;
end;

begin
  GetParameter;
  GetOurEnv;
  if not InitializeInterface(message) then bumout(message);
  Write32(CSRPort+(OurChannel*DataStride),0);
  Runit;
  halt(0);
end.

