{program SDS : stop doit start;}
{$IFDEF WINDOWS}
uses synaser,synautil,synaip,blcksock,dos,crt;
var
ser:TBlockSerial;
TheComPort : string;
IPAddr : string;
Socket : TUDPBlockSocket;
{$ELSE}
uses dos,crt;
var TheComPort : word;
{$ENDIF}

var
Channels : byte;
Mask : byte;
BasePort : word;
Parameter : longint;
Output : comp;
Retcode : integer;
UseHex : boolean;
DoRepeat : boolean;
temp : word;
ParmLoc : integer;
ParmName : string;
c : char;
HaltOnError : boolean;
ErrorFlag : boolean;
DoBSD : boolean;


{$I SELECTC}
{$I SELECTIO}
{$I SELECTP}
{I SELECTPR}
{$I INTERFCE}

const
NumberOfChannels = 8;
DataStride = 4; {bytes}

var
FailedTransferCount : array[0..7] of longint;
count : longint;
Data : longint;
Errors : byte;
Status_State : byte;
Status : byte;
State : byte;
Command : word;
Wait : longint;

procedure ClearFailedTransferCount;
var index : integer;
begin
  for index := 0 to 7 do
  begin
    FailedTransferCount[index] := 0;
  end;
end;

procedure Error(err : integer);
begin
  ErrorFlag := true;
  writeln;
  writeln(errorrecord[err].errstr);
  if HaltOnError then halt(2);
end;

procedure Usage;
begin
  writeln;
  writeln('USAGE: SDS Start_Chans  [Start_Mask] BSD');
  writeln('Start_Chans is (hex) channels to start');
  writeln('Start_Mask is (hex) channels expected to start');
  writeln('BSD enables bootstrap drain delay during stop ');
  halt(2);
end;

procedure GetParameter;
begin
  DoBSD := false;
  if Paramcount < 1 then Usage;
  if not HexByteRead(ParamStr(1),Channels) then Bumout('Bad start selector');
  Mask := $FF;
  if ParamCount >1 then
  begin
    if not HexByteRead(ParamStr(2),Mask) then Bumout('Bad start mask');
  end;
  if ParamCount >2 then
  begin
    if upstring(ParamStr(3)) = 'BSD' then DoBSD := true;
  end;
end;  { GetParameter }

procedure TestLoop;
var
loopcount,longdata : longint;
foochar : char;
result : byte;
hs : string;
doitloop : integer;
cindex,error : byte;
wbyte,rbyte : byte;
wword,rword : word;
wlong,rlong : longint;
wdouble,rdouble : comp;

begin
  HaltOnError := true;
  ErrorFlag := false;
  for cindex := 0 to 7 do
  begin
     Write32(CSRPort+(cindex*DataStride),0);
  end;
  loopcount := 0;
  Output := 1;
  SSLBPStopAll;
  delay(200);
  while not keypressed do
  begin
    result := Start(Channels);
    if (result and Mask) <> 0 then
    begin
      writeln;
      hs := HexString(result,2);
      Bumout('Failed to Start: '+hs);
    end;
    for doitloop := 1 to 13 do
    begin
      for cindex := 0 to 7 do
      begin
        if (1 shl cindex) and Mask <> 0 then
        begin
          Write32(InterfacePort0+(cindex*DataStride),DoubleLongRec(Output).long0);
          Write32(InterfacePort1+(cindex*DataStride),DoubleLongRec(Output).long1);
          longdata := Read32(CSRPort+(cindex*DataStride));
          error := longintbyterec(longdata).byte0;
          if error <> 0 then
          begin
            write(' Count:',loopcount,' Channel ',cindex,' Start Error: ');
            hexprint(error,2);
            Bumout(' ');
          end;
        end;
      end;
      result := Doit(Channels);
      if (result and Mask) <> 0 then
      begin
        writeln;
        hs := HexString(result,2);
        Bumout('Failed to DOIT: '+hs);
      end;
      Output := Output + Output;
      if Output > 2.80e14 then Output := 1; { start again }
    end;
    {SSLBPStopAll;}
    SSLBPStop(Channels);
    result := StartSetup(Channels);
    if (result and Mask) <> 0 then
    begin
      writeln;
      hs := HexString(result,2);
      Bumout('Failed to StartSetup: '+hs);
    end;

    { ok check read/write and errors }
    HaltOnError := false;

    for doitloop := 1 to 11 do
    begin
      for Axis := 0 to 7 do
      begin
        if (1 shl Axis) and Mask <> 0 then
        begin
          longdata := Read32(CSRPort+(Axis*DataStride));
          error := longintbyterec(longdata).byte0;
          if error <> 0 then
          begin
            write('Count:',loopcount,' Channel ',Axis,' StartS Error: ');
            hexprint(error,2);
            Bumout(' ');
          end;
          wbyte := $12;
          WriteByte(BiggerCookieLoc,wbyte);
          rbyte := ReadByte(BiggerCookieLoc);
          if rbyte <> wbyte then
          begin
            write('Byte read failed read: ',hexstring(longint(rbyte),2));
            writeln(' should be ',hexstring(longint(wbyte),2));
            halt(3);
          end;
          if ErrorFlag then bumout('SSLBP Byte read/write failed to complete');

          wword := $1234;
          WriteWord(BiggerCookieLoc,wword);
          rword := ReadWord(BiggerCookieLoc);
          if rword <> wword then
          begin
            write('Word read failed read: ',hexstring(longint(rword),4));
            writeln(' should be ',hexstring(longint(wword),4));
            halt(3);
          end;
          if ErrorFlag then bumout('SSLBP Word read/write failed to complete');

          wlong := $12345678;
          WriteLong(BiggerCookieLoc,wlong);
          rlong := ReadLong(BiggerCookieLoc);
          if rlong <> wlong then
          begin
            write('Long read failed read: ',hexstring(rlong,8));
            writeln(' should be ',hexstring(wlong,8));
          end;
          DoubleLongRec(wdouble).Long1 := $12345678;
          DoubleLongRec(wdouble).Long0 := $9ABCDEF0;
          WriteDouble(BiggerCookieLoc,wdouble);
          rdouble := ReadDouble(BiggerCookieLoc);
          if rdouble <> wdouble then
          begin
            write('Double read failed read: '
             ,hexstring(DoubleLongRec(rdouble).Long1,8),hexstring(DoubleLongRec(rdouble).Long0,8));
            writeln(' should be ',hexstring(DoubleLongRec(wdouble).Long1,8),hexstring(DoubleLongRec(wdouble).Long0,8));
            halt(3);
          end;
        end;
        if ErrorFlag then bumout('SSLBP Double read/write failed to complete');
      end;
    end;
    {SSLBPStopAll;}
    SSLBPStop(Channels);

    loopcount := loopcount +1;
    if (loopcount mod 100) = 0 then
    begin
      write(chr(13),'Pass Count = ',loopcount);
      delay(100); {this is to guarantee the remote watchdog times out}
      if DoBSD then delay(2000); {this is to guarantee the bootstrap drains }
    end;
  end;
  writeln;
  foochar:=readkey;
end;

begin
  GetParameter;
  GetOurEnv;
  if not InitializeInterface(message) then bumout(message);
  TestLoop;
  halt(0);
end.

{3-12 added checking for errors in start and starts and check cookie in starts }
{ channel stop instead of stopall }
{3-20-12 instead of checking cookie do read write of 8,16,32,64 bit values}
