program SDMCWriteParamDirect;

{$DEFINE COPROC}
{$IFDEF COPROC}
{$N+}
{$ELSE}
{$N-}
{$ENDIF}

{DEFINE DEBUG}
{DEFINE DSPIC} { for 3C20 }
{DEFINE SEVENI64} { for 7I64 }
{DEFINE EIGHTI20} { for 8I20 }
{DEFINE WINDOWS}
{$IFDEF WINDOWS}

uses synaser,synautil,synaip,blcksock,dos,crt;
var
ser:TBlockSerial;
TheComPort : string;
IPAddr : string;
Socket : TUDPBlockSocket;
{$ELSE}
uses dos,crt;
var TheComPort : word;
{$ENDIF}


var
BasePort : word;
Parameter : comp;
Retcode : integer;
UseHex : boolean;
DoRepeat : boolean;
ByteData : byte;
ByteLoc : byte;
ParmLoc : integer;
ParmName : string;
cookie : byte;

{$I SELECTC}
{$I SELECTIO}
{I SELECTP}
{$I SELECTPR}
{$I INTERFCE}

var
Parmtype : ParameterType;

procedure Error(err : integer);
begin
  writeln(errorrecord[err].errstr);
  halt(2);
end;

procedure Usage;
begin
  writeln('Usage: wp parm data [axis] [q] [h]');
  writeln;
  halt(2);
end;

function FindParm(aname : string) : boolean;
var
index : integer;
cname : string;
offset : word;
retcode : integer;
begin
  cname := StripTillChar(aname,'+');
  offset := 0;
  if length(aname) >0 then
  begin
    val(aname,offset,retcode);
    if retcode <> 0 then BumOut('Can''t parse offset');
  end;
  index := 1;
  while (upstring(cname) <> upstring(SDMCParams[index].ParmName)) and (index <= LastParm) do index := index +1;
  ParmLoc := SDMCParams[index].ParmLoc + offset;
  ParmType := SDMCParams[index].ParmType;
  ParmName := SDMCParams[index].ParmName; {so it will have the cannonical name}
  if index > LastParm then FindParm := false else findparm := true;
end;

procedure Pause;
var foo : string;
begin
  writeln;
  writeln('Press return to continue');
  readln(foo);
end;

procedure ShowParameters(s : string);
var index,lc : integer;
begin
  writeln('No such parameter: '+s);
  writeln('Valid parameters are: ');
  lc := 0;
  for index := 1 to LastParm do
  begin
    if (index mod 4) = 0 then
    begin
      writeln;
      lc := lc +1;
    end;
    if lc > 19 then
    begin
      Pause;
      lc := 0;
    end;
    write(PadWithSpaces(SDMCParams[index].ParmName,19));
  end;
  writeln;
  halt(2);
end;

procedure GetParameter;
var
hstring,nstring : string;
temp : comp;
wtemp : word;
index : word;
begin
  GetOurEnv;
  UseHex := false;
  if length(ParamStr(2)) = 0 then Usage;
  for index := 3 to 5 do
  begin
    if length(ParamStr(index)) > 0 then
    begin
      if upstring(ParamStr(index)) = 'H' then UseHex := true;
      if upstring(ParamStr(index)) = 'R' then DoRepeat := true;
    end;
  end;
  if not FindParm(ParamStr(1)) then ShowParameters(ParamStr(1));
  Axis := 0;
  if UseHex = false then
  begin
    val(ParamStr(2),temp,Retcode);
    if retcode = 0 then Parameter := temp else Usage;
  end
  else
  begin
   if not HexDoubleRead(ParamStr(2),Parameter) then Usage;
  end;
  if length(ParamStr(3)) > 0 then
  begin
    val(ParamStr(3),wtemp,Retcode);
    if retcode = 0 then Axis := wtemp;
  end;
end;  { GetParameter }

begin
  GetParameter;
  Message := 'Setup Mode';
  if not InitializeInterface(Message) then bumout(Message);

  repeat
    if (parmtype = type_byte) then
    begin
      if Parameter > 255 then Bumout('Parameter is too big for '+ParmName);
      WriteByte(ParmLoc,DoubleIntRec(Parameter).word0);
    end;

    if (parmtype = type_uint) or (parmtype = type_int) or (parmtype = type_ptr)
      or (parmtype = type_mask) or (parmtype = type_flag) then
    begin
      if Parameter > 65535 then Bumout('Parameter is too big for '+ParmName);
      WriteWord(ParmLoc,DoubleIntRec(Parameter).word0);
    end;

{$IFNDEF SEVENI64}
    if ParmType = type_elong then
    begin
      {if Parameter > 4294967295 then Bumout('Parameter is too big for '+ParmName);}
      WriteEEPROMLong(ParmLoc,DoubleLongRec(Parameter).Long0);
     {if  LBPReadStatus <> 0 then bumout('Invalid address ');}
    end;

    if ParmType = type_eword then
    begin
      if Parameter > 65535 then Bumout('Parameter is too big for '+ParmName);
      WriteEEPROMWord(ParmLoc,DoubleIntRec(Parameter).word0);
     {if  LBPReadStatus <> 0 then bumout('Invalid address ');}
    end;

    if ParmType = type_ebyte then
    begin
      if Parameter > 255 then Bumout('Parameter is too big for '+ParmName);
      WriteEEPROMByte(ParmLoc,DoubleByteRec(Parameter).Byte0);
     {if  LBPReadStatus <> 0 then bumout('Invalid address ');}
    end;
{$ENDIF}

    if (ParmType = type_ulong) or (ParmType = type_long) then WriteLong(ParmLoc,DoubleLongRec(Parameter).long0);

    if ParmType = type_Double then WriteDouble(ParmLoc,Parameter);

  if SerError then bumout('Serial Timeout Error');
  until (not DoRepeat) or KeyPressed;
  halt(2);
end.
